<template>
  <div>
    <Vuemik
      :initialValues="initialValues"
      :onSubmit="addItem"
      :validationSchema="validationSchema"
    >
      <template v-slot:default="{ handleSubmit, empty, errors, reset }">
        <Field type="text" name="itemName" />
        <Field type="checkbox" name="completed" />

        <!--<Field
          component="ImprovedSelect"
          name="category2"
          :options="categories"
        />-->

        <Field component="select" name="category" :onChange="setArticles">
          <option v-for="item in categories" :key="item" :value="item">
            {{ item }}
          </option>
        </Field>

        <Field component="select" name="article">
          <option v-for="item in articles" :key="item" :value="item">
            {{ item }}
          </option>
        </Field>

        <button @click="handleSubmit">Add item</button>
        <button @click="empty">Empty</button>
        <button @click="reset">Reset</button>

        <ul v-for="error in errors" :key="error">
          <li>{{ error }}</li>
        </ul>
      </template>
    </Vuemik>
  </div>
</template>

<script>
import Vuemik from '@/components/Vuemik.vue';
import Field from '@/components/Field.vue';
import * as Yup from "yup";

const options = {
  cuisine: ["cuillères", "fouchettes", "couteaux"],
  salon: ["canapé", "TV"],
};

export default {
  name: "Form",
  data: () => ({
    initialValues: {
      itemName: "test",
      completed: false,
      category: Object.keys(options)[0],
      article: "",
    },
    articles: Object.values(options)[0],
  }),
  components: {
    Vuemik,
    Field 
  },
  methods: {
    addItem: function (values) {
      this.$emit("add-todo", values);
    },
    setArticles: function (e){
      this.articles = options[e.target.value];
    }
  },
  computed: {
    categories: function () {
      return Object.keys(options);
    },
    //Bonus
    validationSchema: () => {
      return Yup.object().shape({
        itemName: Yup.string()
          .min(2, "Too Short!")
          .max(50, "Too Long!")
          .required("Required"),
        lastName: Yup.string()
          .min(2, "Too Short!")
          .max(50, "Too Long!"),
        email: Yup.string().email("Invalid email"),
      });
    },
  },
};
</script>